" Vim syntax file
" Language:	FLUKA
" Maintainer:	Vasilis.Vlachoudis AT cern.ch
" Last Change:	2003 Nov 3
" URL:
"
" Quit when a syntax file was already loaded
if exists("b:current_syntax")
  set expandtab
  finish
endif

set expandtab
"syn case ignore

" Integers (Error)
syn match flukaNumber	excludenl "\<[-+]\=\d\+\>" "containedin=flukaWhat
syn match flukaNumber	excludenl "\<[-+]\=\d\+OR"me=e-2 "containedin=flukaWhat

" Floating point numbers
syn match flukaFloat	excludenl "[-+]\=\d\+\." "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\.\d\+" "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\d\+\.\d\+" "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\d\+[eEdD][-+]\=\d\+" "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\d\+\.[eEdD][-+]\=\d\+" "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\d\+\.\d\+[eEdD][-+]\=\d\+" "containedin=flukaWhat
syn match flukaFloat	excludenl "[-+]\=\.\d\+[eEdD][-+]\=\d\+" "containedin=flukaWhat

" Identifier
"syn match flukaIdentifier excludenl "\<\i\+\>"

"syn region flukaGeom	start="/^GEOBEGIN\>/1" end="/^GEOEND\>/-1" contains=flukaPrim,flukaPrimAny,flukaEND,flukaOR,flukaComment,flukaWhat

" Considered keywords when used together in a phrase and begin a clause
syn match flukaTitleCard	excludenl "^TITLE\>" containedin=flukaTitle
syn match flukaTitle		"^TITLE\>\s*\_..*$" contains=flukaTitleCard

syn match flukaCard	excludenl "^ASSIGNMA[ tT]"
syn match flukaCard	excludenl "^BAMJET\>"
syn match flukaCard	excludenl "^BEAMAXES\>"
syn match flukaCard	excludenl "^BEAMPOS\>"
syn match flukaCard	excludenl "^BEAM\>"
syn match flukaCard	excludenl "^BIASING\>"
syn match flukaCard	excludenl "^BME\>"
syn match flukaCard	excludenl "^COMMENT\>"
syn match flukaCard	excludenl "^COMPOUND\>"
syn match flukaCard	excludenl "^CORRFACT\>"
syn match flukaCard	excludenl "^DCYSCORE\>"
syn match flukaCard	excludenl "^DCYTIMES\>"
syn match flukaCard	excludenl "^DEFAULTS\>"
syn match flukaCard	excludenl "^DELTARAY\>"
syn match flukaCard	excludenl "^DETECT\>"
syn match flukaCard	excludenl "^DISCARD\>"
syn match flukaCard	excludenl "^DPMJET\>"
syn match flukaCard	excludenl "^DPM-PARA\>"
syn match flukaCard	excludenl "^ELCFIELD\>"
syn match flukaCard	excludenl "^EMFCUT\>"
syn match flukaCard	excludenl "^EMFFIX\>"
syn match flukaCard	excludenl "^EMFFLUO\>"
syn match flukaCard	excludenl "^EMFRAY\>"
syn match flukaCard	excludenl "^EMF\>"
syn match flukaCard	excludenl "^EMF-BIAS\>"
syn match flukaCard	excludenl "^EVENTBIN\>"
syn match flukaCard	excludenl "^EVENTDAT\>"
syn match flukaCard	excludenl "^EVENTYPE\>"
syn match flukaCard	excludenl "^EVXTEST\>"
syn match flukaCard	excludenl "^EXPTRANS\>"
syn match flukaCard	excludenl "^FLUKAFIX\>"
syn match flukaCard	excludenl "^FREE\>"
syn match flukaCard	excludenl "^GEOBEGIN\>"
syn match flukaCard	excludenl "^GEOEND\>"
syn match flukaCard	excludenl "^GLOBAL\>"
syn match flukaCard	excludenl "^HI-PROPE\>"
syn match flukaCard	excludenl "^IONFLUCT\>"
syn match flukaCard	excludenl "^IRRPROFI[ lL][ eE]"
syn match flukaCard	excludenl "^LAM-BIAS\>"
syn match flukaCard	excludenl "^LATTICE\>"
syn match flukaCard	excludenl "^LOW-BIAS\>"
syn match flukaCard	excludenl "^LOW-DOWN\>"
syn match flukaCard	excludenl "^LOW-MAT\>"
syn match flukaCard	excludenl "^LOW-NEUT\>"
syn match flukaCard	excludenl "^MAT-PROP\>"
syn match flukaCard	excludenl "^MATERIAL\>"
syn match flukaCard	excludenl "^MCSTHRES[ hH]"
syn match flukaCard	excludenl "^MGNFIELD\>"
syn match flukaCard	excludenl "^MULSOPT\>"
syn match flukaCard	excludenl "^MUPHOTON\>"
syn match flukaCard	excludenl "^MYRQMD\>"
syn match flukaCard	excludenl "^OPEN\>"
syn match flukaCard	excludenl "^OPT-PROD\>"
syn match flukaCard	excludenl "^OPT-PROP\>"
syn match flukaCard	excludenl "^PAIRBREM\>"
syn match flukaCard	excludenl "^PART-THR[ eE][ sS]"
syn match flukaCard	excludenl "^PHOTONUC\>"
syn match flukaCard	excludenl "^PHYSICS\>"
syn match flukaCard	excludenl "^PLOTGEOM\>"
syn match flukaCard	excludenl "^POLARIZA[ tT][ iI]"
syn match flukaCard	excludenl "^POLARIZA\>"
syn match flukaCard	excludenl "^RADDECAY\>"
syn match flukaCard	excludenl "^RANDOMIZ[ eE]"
syn match flukaCard	excludenl "^RESNUCLE[ iI]"
syn match flukaCard	excludenl "^ROT-DEFI[ nN][ iI]"
syn match flukaCard	excludenl "^ROTPRBIN\>"
syn match flukaCard	excludenl "^RQMD\>"
syn match flukaCard	excludenl "^SCORE\>"
syn match flukaCard	excludenl "^SOURCE\>"
syn match flukaCard	excludenl "^START\>"
syn match flukaCard	excludenl "^STEPSIZE\>"
syn match flukaCard	excludenl "^STERNHEI[ mM][ eE]"
syn match flukaCard	excludenl "^STOP\>"
syn match flukaCard	excludenl "^TCQUENCH\>"
syn match flukaCard	excludenl "^THRESHOL[ dD]"
syn match flukaCard	excludenl "^TIME-CUT\>"
syn match flukaCard	excludenl "^TITLE\>"
syn match flukaCard	excludenl "^USERDUMP\>"
syn match flukaCard	excludenl "^USERWEIG[ tT][ hH]"
syn match flukaCard	excludenl "^USERWEIG\>"
syn match flukaCard	excludenl "^USRBDX\>"
syn match flukaCard	excludenl "^USRBIN\>"
syn match flukaCard	excludenl "^USRCOLL\>"
syn match flukaCard	excludenl "^USRICALL\>"
syn match flukaCard	excludenl "^USROCALL\>"
syn match flukaCard	excludenl "^USRTRACK\>"
syn match flukaCard	excludenl "^USRYIELD\>"
syn match flukaCard	excludenl "^WW-FACTO[ rR]"
syn match flukaCard	excludenl "^WW-PROFIL[ eE]"
syn match flukaCard	excludenl "^WW-THRES[ hH]"

syn match flukaEnd	excludenl "^STOP\>"
syn match flukaEnd      excludenl "^  END\>" "contained
syn match flukaEnd      excludenl "^END\>" "contained


" Obsolete Cards
syn match flukaObsolete excludenl "^ACCURACY\>"
syn match flukaObsolete	excludenl "^DUMPTHEM\>"
syn match flukaObsolete	excludenl "^EGSCUT\>"
syn match flukaObsolete	excludenl "^EGSFIX\>"
syn match flukaObsolete	excludenl "^EGSFLUO\>"
syn match flukaObsolete	excludenl "^EGSRAY\>"
syn match flukaObsolete	excludenl "^EGS\>"
syn match flukaObsolete	excludenl "^EXTRAWEI[ gG][ tT]"
syn match flukaObsolete	excludenl "^LANDAU\>"
syn match flukaObsolete	excludenl "^OUTLEVEL\>"

" Comments
syn match flukaComment	excludenl "^\*.*$"

" Pre Processor
syn match flukaPreProc	excludenl "^#.*$"
"syn region flukaPpOut	excludenl start="#if\s\+0\s*" end="^#\(endif\>\|else\>\|elif\>\)" contains=flukaPreProc2
syn region flukaPpOut	start="#if\s\+0\s*"ms=e end="^#endif\s*"ms=s
syn cluster flukaPreProcGroup	contains=flukaPreProc,flukaPpOut

syn keyword flukaTodo contained	TODO FIXME XXX

"syn match flukaWhat1	excludenl "\%11v.\{0,10}" contains=flukaFloat,flukaNumber
"syn match flukaWhat2	excludenl "\%21v.\{0,10}" contains=flukaFloat,flukaNumber
"syn match flukaWhat3	excludenl "\%31v.\{0,10}" contains=flukaFloat,flukaNumber
"syn match flukaWhat4	excludenl "\%41v.\{0,10}" contains=flukaFloat,flukaNumber
"syn match flukaWhat5	excludenl "\%51v.\{0,10}" contains=flukaFloat,flukaNumber
"syn match flukaWhat6	excludenl "\%61v.\{0,10}" contains=flukaFloat,flukaNumber

syn match flukaSDUM	excludenl ".\%>71v"
"syn match flukaWhatLine excludenl ".\%>11v" contains=flukaWhat,flukaSDUM

syn match flukaPrim	excludenl "^  ARB " "contained
syn match flukaPrim	excludenl "^  BOX " "contained
syn match flukaPrim	excludenl "^  ELL " "contained
syn match flukaPrim	excludenl "^  PLA " "contained
syn match flukaPrim	excludenl "^  RAW " "contained
syn match flukaPrim	excludenl "^  RCC " "contained
syn match flukaPrim	excludenl "^  REC " "contained
syn match flukaPrim	excludenl "^  RPP " "contained
syn match flukaPrim	excludenl "^  SPH " "contained
syn match flukaPrim	excludenl "^  TRC " "contained
syn match flukaPrim	excludenl "^  WED " "contained
syn match flukaPrim	excludenl "^  XCC " "contained
syn match flukaPrim	excludenl "^  XEC " "contained
syn match flukaPrim	excludenl "^  XYP " "contained
syn match flukaPrim	excludenl "^  XZP " "contained
syn match flukaPrim	excludenl "^  YCC " "contained
syn match flukaPrim	excludenl "^  YEC " "contained
syn match flukaPrim	excludenl "^  YZP " "contained
syn match flukaPrim	excludenl "^  ZCC " "contained
syn match flukaPrim	excludenl "^  ZEC " "contained

syn match flukaPrim	excludenl "^ARB " "contained
syn match flukaPrim	excludenl "^BOX " "contained
syn match flukaPrim	excludenl "^ELL " "contained
syn match flukaPrim	excludenl "^PLA " "contained
syn match flukaPrim	excludenl "^RAW " "contained
syn match flukaPrim	excludenl "^RCC " "contained
syn match flukaPrim	excludenl "^REC " "contained
syn match flukaPrim	excludenl "^RPP " "contained
syn match flukaPrim	excludenl "^SPH " "contained
syn match flukaPrim	excludenl "^TRC " "contained
syn match flukaPrim	excludenl "^WED " "contained
syn match flukaPrim	excludenl "^XCC " "contained
syn match flukaPrim	excludenl "^XEC " "contained
syn match flukaPrim	excludenl "^XYP " "contained
syn match flukaPrim	excludenl "^XZP " "contained
syn match flukaPrim	excludenl "^YCC " "contained
syn match flukaPrim	excludenl "^YEC " "contained
syn match flukaPrim	excludenl "^YZP " "contained
syn match flukaPrim	excludenl "^ZCC " "contained
syn match flukaPrim	excludenl "^ZEC " "contained

syn match flukaOR	excludenl "\%11vOR" "contained
syn match flukaOR	excludenl "\%18vOR" "contained
syn match flukaOR	excludenl "\%25vOR" "contained
syn match flukaOR	excludenl "\%32vOR" "contained
syn match flukaOR	excludenl "\%39vOR" "contained
syn match flukaOR	excludenl "\%46vOR" "contained
syn match flukaOR	excludenl "\%53vOR" "contained
syn match flukaOR	excludenl "\%60vOR" "contained
syn match flukaOR	excludenl "\%67vOR" "contained

"syn region flukaGeom	start="^GEOBEGIN\>" end="^GEOEND\>" contains=flukaPrim,flukaPrimAny,flukaEND,flukaOR,flukaComment,flukaWhat

syn match flukaTab		"\t"
syn match flukaEmptyLine	"^$"
syn match flukaEmptyLine	"^\s*$"

syn match flukaGeoTitle		"^GEOBEGIN\>.*\_..*$" contains=flukaCard,flukaNumber,flukaFloat,flukaSDUM,flukaTab

" Catch errors caused by wrong parenthesis
syn region flukaParen transparent start='(' end=')' contains=ALLBUT,flukaParenError,flukaTodo
syn match flukaParenError	 ")"
syn match flukaInParen		"[\\[\\]{}]"

" The default highlighting.
hi def link flukaIdentifier	Normal
hi def link flukaTitle		Title
hi def link flukaTitleCard	Statement
hi def link flukaGeoTitle	String
hi def link flukaCard		Statement
hi def link flukaPrim		Function
hi def link flukaPrimAny	Function
hi def link flukaComment	Comment
hi def link flukaPreProc	PreProc
hi def link flukaEnd		WarningMsg
hi def link flukaOR		Type
hi def link flukaSDUM		Type
hi def link flukaSkip		flukaPpOut
hi def link flukaPpOut		Comment
"hi flukaFloat	guifg=#000000
"hi def link flukaIdentifier	Identifier

hi def link flukaParenError	Error
hi def link flukaInParen	Error
hi def link flukaTab		Error
hi def link flukaEmptyLine	Error
hi def link flukaObsolete	Error
hi def link flukaNumber		WarningMsg

hi def link flukaFloat		Normal

"hi flukaWhat1 guibg=#ffffff
"hi flukaWhat2 guibg=#f0f0f0
"hi flukaWhat3 guibg=#ffffff
"hi flukaWhat4 guibg=#f0f0f0
"hi flukaWhat5 guibg=#ffffff
"hi flukaWhat6 guibg=#f0f0f0

"hi def link flukaFloatNoDec	Float
"hi def link flukaFloatIniDec	Float
"hi def link flukaFloatEndDec	Float
"hi def link flukaFloatDExp	Float

let b:current_syntax = "fluka"
